
CoCoALib - Feature #1770

Evaluate polynomial function/class

21 Nov 2023 23:15 - John Abbott

Status: Closed Start date: 21 Nov 2023

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: New Function Estimated time: 3.11 hours

Target version: CoCoALib-0.99850 Spent time: 3.10 hours

Description

Create a class(?) to make it easier to evaluate polynomials.

A first prototype is in SparsePolyOps-cyclotomic  (historical quirk).

It is called EvalUPoly, and is usefully faster than using a RingHom.

Improve the design, and make it a proper new feature of CoCoALib

Related issues:

Related to CoCoALib - Slug #1769: FixedDivisor is sometimes surprisingly slow Closed 20 Nov 2023

History

#1 - 21 Nov 2023 23:15 - John Abbott

- Related to Slug #1769: FixedDivisor is sometimes surprisingly slow added

#2 - 21 Nov 2023 23:17 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

I made a quick prototype, and used it in a revised version of FixedDivisor (in PolyRing.C).

It made the code about 20 times faster (on a nasty example).

Must think about the interface, and possible generalizations.

NOTE: also move it out of SparsePolyOps-cyclotomic... but to where?

#3 - 09 Dec 2023 13:43 - John Abbott

- Status changed from In Progress to Resolved

- Assignee set to John Abbott

- % Done changed from 10 to 80

I have separated the evaluation code from the cyclotomic code, and put it in a new file.

Must still document the new code:  the interface is reasonable (but might be migliorabile).

#4 - 07 Mar 2024 20:20 - John Abbott

- Status changed from Resolved to Feedback

- % Done changed from 80 to 90

The new code is in SparsePolyOps-eval

The current impl is rather restricted: the polynomial has to be over ZZ, and the evaluation point must be INT/RAT.
I suggest making this "incomplete" implementation available; we can later make it more complete -- not especially hard, but will take some time.

#5 - 16 Mar 2024 21:52 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 3.11 h
